// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
using namespace std;

int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
  myofs << "Team 123,   . 18  2008 ." << endl; 
  myofs << "  4-18.    " << endl << endl; 
  }
  {
    myofs << " 1.  :" << endl;
    const int M=12, N=8; int m, n;
    double a[M][N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = m*n;
    }
    for(m=0; m<M; m++){
      for(n=0; n<N; n++){
        myofs << "  a[" << setw(2) << m << "," << setw(2) << n << "]=" << setw(5) << setprecision(1) << a[m][n];
      }
      myofs << endl;
    }
  }
  {
    myofs << " 2.  :" << endl;
    const int M=12, N=12; int m, n;
    double a[M][N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = m*n;
    }
      myofs << "    ";
    for(n=0; n<N; n++){myofs << setw(6) << n;} myofs << endl;
    for(m=0; m<M; m++){
      myofs << setw(3) << m << "  ";
      for(n=0; n<N; n++){
        myofs << setw(6) << setprecision(1) << a[m][n];
      }
      myofs << endl;
    }
  }
  {
    myofs << " 3.   " << endl;
    const int M=12, N=8; int m, n, m1, m2, n1, n2;
    double d1, d2, d3, a[M][N];
    double ar1[M], ar2[M], ac1[N], ac2[N];
    int ir1[M], ir2[M], ic1[N], ic2[N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = 10.0*((double(rand())/double(RAND_MAX))*2.0-1.0);
    }
    for(m=0; m<M; m++){
      d1=d2=a[m][0]; n1=n2=0;
      for(n=1; n<N; n++){
        d3=a[m][n];
        if(d3<d1){d1=d3; n1=n;}
        if(d3>d2){d2=d3; n2=n;}
      }
      ar1[m]=d1;
      ar2[m]=d2;
      ir1[m]=n1;
      ir2[m]=n2;
    }
    for(n=0; n<N; n++){
      d1=d2=a[0][n]; m1=m2=0;
      for(m=1; m<M; m++){
        d3=a[m][n];
        if(d3<d1){d1=d3; m1=m;}
        if(d3>d2){d2=d3; m2=m;}
      }
      ac1[n]=d1;
      ac2[n]=d2;
      ic1[n]=m1;
      ic2[n]=m2;
    }
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << " [" << setw(2) << ic2[n] << "," << n << "]";} myofs << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac2[n];} myofs << endl;
    myofs << "                 ------------------------------------------------------------" << endl;
    for(m=0; m<M; m++){
      myofs << "a[" << setw(2) << m << "," << setw(1) << ir1[m] << "]=" << setw(7) << setprecision(3) << ar1[m] << " || ";
      for(n=0; n<N; n++){
        myofs << setw(7) << setprecision(3) << a[m][n];
      }
      myofs << " || a[" << setw(2) << m << "," << setw(1) << ir2[m] << "]=" << setw(7) << setprecision(3) << ar2[m] << endl;
    }
    myofs << "                 ------------------------------------------------------------" << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << " [" << setw(2) << ic1[n] << "," << n << "]";} myofs << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac1[n];} myofs << endl;
  }
  {
    myofs << " 4.  " << endl;
    const int M=100;
    const int N=72;
    const int K=8;
    char* t[M];
    char buf[256];
    for(int m=0; m<M; m++){
      int n=1+rand()%(K-1);
      t[m]=new char[n+1];
      for(int k=0; k<n; k++)
        buf[k]=char(-32+rand()%31);
      buf[n]='\0';
      strcpy(t[m], buf);
    }
    int counter=0;
    for(int m=0; m<M; m++){
      myofs << t[m] << " ";
      counter += strlen(t[m]);
      if(counter>N){
        counter=0;
        myofs << endl;
      }
    }
    for(int m=0; m<M; m++)
      delete[] t[m];
  }
  myofs.close();
  myofs.open("MyBook.txt");
  {
    myofs << endl << endl << " 5. ,    " << endl;
    const int L=10;
    char sample[L][100];
    int sc[L]; 
    for(int n=0; n<L; n++) sc[n]=0;
      ifstream smp;
      smp.open("test.txt");
      for(int n=0; n<L; n++) smp >> sample[n];
      smp.close();
    const int N=100000;
    char* t[N];
    char buf[10000];
    myifs.open("pz.txt");
    int wordcounter=0, k;
    while(true){
      myifs >> buf;
      for(int n=0; n<10; n++){
        if(strcmp(sample[n], buf)==0) sc[n]++;
      }
      k=strlen(buf);
      if(k<=0) break; 
      t[wordcounter] = new char[k+1];
      strcpy(t[wordcounter], buf);
      wordcounter++;
      if(wordcounter>=N)break;
    }
    myifs.close();
    for(int n=0; n<L; n++){
      myofs << setw(12) << sample[n] << " " << setw(6) << sc[n] << endl;
    }
    int charcounter=0;
    for(int n=0; n<wordcounter; n++){
      myofs << t[n] << " ";
      charcounter += strlen(t[n]);
      if(charcounter>100){
        myofs << endl;
        charcounter=0;
      }
    }
  }
  myofs.close();
  return 0;
}

